﻿using System;
using Microsoft.Rtc.Collaboration.AudioVideo;
using Microsoft.Rtc.Signaling;
using Microsoft.Rtc.Collaboration;
using Microsoft.Speech.Synthesis;
using Microsoft.Speech.AudioFormat;

namespace UCMACoreWorkflow
{
    public class PhoneMenuInitialCallHandler
    {
        public static CallController PhoneMenuCallController = CallController.Instance;

        async internal void Start()
        {
            try
            {
                //TODO: 3.2.3 - Accept the incoming call 
                await PhoneMenuCallController.AVCall.AcceptAsync(null as CallAcceptOptions);
                Console.WriteLine("Accepted call.");

                //TODO: 3.2.4 - Attach speech synthesizer to the call
                var synthConnector = new SpeechSynthesisConnector();
                PhoneMenuCallController.SpeechSynthesizer = new SpeechSynthesizer();
                var format =
                    new SpeechAudioFormatInfo(
                        16000,
                        AudioBitsPerSample.Sixteen,
                        Microsoft.Speech.AudioFormat.AudioChannel.Mono);
                PhoneMenuCallController.SpeechSynthesizer.SetOutputToAudioStream(synthConnector.Stream, format);
                synthConnector.AttachFlow(PhoneMenuCallController.AVCall.Flow);
                synthConnector.Start();
                Console.WriteLine("Speech synthesis connector attached.");

                new PhoneMenuActivity1Handler().Start();
            }
            catch (InvalidOperationException ex)
            {
                Console.WriteLine(ex);
            }
            catch (RealTimeException ex)
            {
                Console.WriteLine(ex);
            }
        }
    }
}
