﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Rtc.Collaboration.AudioVideo;
using Microsoft.Speech.Synthesis;

namespace UCMACoreWorkflow
{
    public class CallController
    {
        static CallController() { }
        private CallController() { }

        static readonly CallController _instance = new CallController();
        public static CallController Instance
        {
            get
            {
                return _instance;
            }
        }

        private AudioVideoCall _avCall;
        public AudioVideoCall AVCall 
        {
            get
            {
                return _avCall;
            }
            set
            {
                _avCall = value;
            }
        }

        private SpeechSynthesizer _speechSynthesizer;
        public SpeechSynthesizer SpeechSynthesizer
        {
            get
            {
                return _speechSynthesizer;
            }
            set
            {
                _speechSynthesizer = value;
            }
        }

        private ToneController _toneController;
        public ToneController ToneController
        {

            get
            {
                if (_toneController == null)
                {
                    if (_avCall != null)
                    {
                        _toneController = new ToneController();
                        _toneController.AttachFlow(_avCall.Flow);
                    }
                }
                return _toneController;
            }
        }
    }
}
