﻿using System;
using Microsoft.Rtc.Collaboration.AudioVideo;
using Microsoft.Rtc.Signaling;
using Microsoft.Rtc.Collaboration;
using Microsoft.Speech.Synthesis;
using Microsoft.Speech.AudioFormat;

namespace UCMACoreWorkflow
{
    public class PhoneMenuActivity1Handler
    {
        public static CallController PhoneMenuCallController = CallController.Instance;

        async internal void Start()
        {
            try
            {
                //TODO: 3.2.5 - Activity implements necessary events

                Console.WriteLine("Tone controller attached.");

                PlayMenu(MenuType.Initial);
            }
            catch (InvalidOperationException ex)
            {
                Console.WriteLine(ex);
            }
            catch (RealTimeException ex)
            {
                Console.WriteLine(ex);
            }
        }

        void PlayMenu(MenuType type)
        {
            Console.WriteLine("Playing {0} menu.", type);
            if (type == MenuType.Initial)
            {
                //TODO: 3.2.6 - Present options to the user

            }
            else if (type == MenuType.Error)
            {
                PhoneMenuCallController.SpeechSynthesizer.SpeakAsync(
                    "Sorry, that is not a valid option. "
                    + "Press 1 to speak to an agent, or 2 to repeat this menu.");
            }
            else
            {
                PhoneMenuCallController.SpeechSynthesizer.SpeakAsync(
                    "Press 1 to speak to an agent, or 2 to repeat this menu.");
            }
        }

        void ToneController_ToneReceived(object sender, ToneControllerEventArgs e)
        {
            Console.WriteLine("Received tone {0}", e.Tone);

            //TODO: 3.2.7 - Handle received tones
            

            if (e.Tone == 1)
            {
                try
                {
                    PhoneMenuCallController.SpeechSynthesizer.Speak(
                        String.Format("You selected option {0}. I'll transfer you now!", e.Tone));

                    RemoveEventHandlers();
                    new PhoneMenuActivity2Handler().Start();
                }
                catch (InvalidOperationException ex)
                {
                    Console.WriteLine(ex);
                }
                catch (RealTimeException ex)
                {
                    Console.WriteLine(ex);
                }
            }
            else if (e.Tone == 2)
            {
                PlayMenu(MenuType.Repeat);
            }
            else
            {
                PlayMenu(MenuType.Error);
            }
        }

        void SpeechSynth_SpeakCompleted(object sender, SpeakCompletedEventArgs e)
        {
            Console.WriteLine("Speech completed");
        }

        void RemoveEventHandlers()
        {
            PhoneMenuCallController.ToneController.ToneReceived
                -= new EventHandler<ToneControllerEventArgs>(ToneController_ToneReceived);
        }
    }
}